on startMovie
  global gFingerCursor, gFistCursor, gSummary, gLst1946LR, gLst1949LR, gLst1950LR, gLst1952LR, gLst1954LR, gLst1955LR, gLst1956LR, gLst1961LR, gLst1963LR, gLst1948, gLst1953, gLst1960, gLst1962, gLst1964, gLstYears, gMarkerName, gBoolRollSound, gWhichYear, gChapter, gUnit, gSoundLevel, gLanguagePref, gCurrentComponent, gDataPath, gBookMark, gBookList, gStudentName, gCDPath, gMainPath, gSplit
  set gSummary to 0
  set gFingerCursor to [the number of member "finger", the number of member "finger mask"]
  set gFistCursor to [the number of member "Fist", the number of member "Fist mask"]
  set gMainPath to checkMainPath()
  set gLstYears to [1946: 0, 1948: 0, 1949: 0, 1950: 0, 1952: 0, 1953: 0, 1954: 0, 1955: 0, 1956: 0, 1960: 0, 1961: 0, 1962: 0, 1963: 0, 1964: 0]
  checkVideo()
  set the textSize of member "ccTextBox" to 12
  if gSplit = 2 then
    setChapterNumber()
  end if
  set gLst1946LR to [6: 0, 11: 0]
  set gLst1948 to []
  set gLst1949LR to [6: 0, 10: 0]
  set gLst1950LR to [6: 0, 7: 0, 10: 0]
  set gLst1952LR to [6: 0]
  set gLst1953 to []
  set gLst1954LR to [6: 0, 7: 0, 17: 0, 18: 0]
  set gLst1955LR to [6: 0, 7: 0, 10: 0]
  set gLst1956LR to [6: 0]
  set gLst1960 to []
  set gLst1961LR to [6: 0, 7: 0, 13: 0, 17: 0]
  set gLst1962 to []
  set gLst1963LR to [6: 0, 12: 0]
  set gLst1964 to []
  set gWhichYear to "1946"
  set gBoolRollSound to 1
  hpuppetTrue(40, 40)
  set notetext to the number of member "notebook text field"
  set the text of member notetext to " "
  set the textFont of member notetext to "helvetica"
  set the textSize of member notetext to 14
  set the margin of member notetext to 3
  set the textStyle of member notetext to "plain"
  set the visible of sprite 9 to 0
  set the visible of sprite 8 to 0
  set the visible of sprite 23 to 0
  set the visible of sprite 29 to 0
  set the visible of sprite 30 to 0
  set the visible of sprite 31 to 0
  set the visible of sprite 32 to 0
  set the visible of sprite 33 to 0
  set the visible of sprite 34 to 0
  set the visible of sprite 35 to 0
  set the visible of sprite 36 to 0
  set the visible of sprite 37 to 0
  set the visible of sprite 38 to 0
  set the visible of sprite 39 to 0
  set the visible of sprite 26 to 0
  set the visible of sprite 27 to 0
  set the puppet of sprite 34 to 0
  set the visible of sprite 46 to 0
  set the visible of sprite 47 to 0
  hCCInitialSetup(28)
  if not voidp(gBookList) then
    set mybookmark to getAt(gBookList, 2)
  end if
  if mybookmark <> 0 then
    LoadBookMark()
  end if
end

on SAveBookmark
  global gBookMark, gBookList, gLstYears
  set gBookMark to string(gLstYears)
end

on LoadBookMark
  global gBookList, gLstYears
  set myList to []
  do("set mylist =  " & getAt(gBookList, 2))
  if not voidp(myList) and listp(myList) then
    set gLstYears to duplicate(myList)
  end if
end

on setChapterNumber
  set chapNumber to 42
  puppetSprite(chapNumber, 1)
  set the castNum of sprite chapNumber to member "split2chap"
end

on hItemDone vWhichList
  set thisSprite to the clickOn
  setProp(vWhichList, thisSprite, 1)
end

on hpuppetTrue vFirstSprite, vLastSprite
  global gFingerCursor
  repeat with n = vFirstSprite to vLastSprite
    puppetSprite(n, 1)
    set the stretch of sprite n to 0
    if the castNum of sprite n = the number of member "hot spot" then
      set the cursor of sprite n to gFingerCursor
      next repeat
    end if
    set the cursor of sprite n to 0
  end repeat
end

on hpuppetFalse vFirstSprite, vLastSprite
  repeat with n = vFirstSprite to vLastSprite
    puppetSprite(n, 0)
  end repeat
end

on hHideSprite vFirstSprite, vLastSprite
  repeat with n = vFirstSprite to vLastSprite
    set the visible of sprite n to 0
  end repeat
end

on hUnHideSprite vFirstSprite, vLastSprite
  repeat with n = vFirstSprite to vLastSprite
    set the visible of sprite n to 1
  end repeat
end

on hDisplay vTransition, vTransTime, vWhichSprite, vwhichMember, vLocA, vLocB
  puppetTransition(vTransition, vTransTime)
  set the castNum of sprite vWhichSprite to the number of member vwhichMember
  set the stretch of sprite vWhichSprite to 0
  set the loc of sprite vWhichSprite to point(vLocA, vLocB)
end

on hPixelize vFirstSprite, vLastSprite
  repeat with n = vFirstSprite to vLastSprite
    hpuppetTrue(vFirstSprite, vLastSprite)
    hDisplay(0, 0, n, "pixel", -1, 1)
  end repeat
end

on hCursorTrue vFirstSprite, vLastSprite
  global gFingerCursor
  set gFingerCursor to [the number of member "finger", the number of member "finger mask"]
  repeat with n = vFirstSprite to vLastSprite
    set the cursor of sprite n to gFingerCursor
  end repeat
end

on hCursorFist vFirstSprite, vLastSprite
  global gFistCursor
  set gFistCursor to [the number of member "Fist", the number of member "Fist mask"]
  repeat with n = vFirstSprite to vLastSprite
    set the cursor of sprite n to gFistCursor
  end repeat
end

on hCursorFalse vFirstSprite, vLastSprite
  repeat with n = vFirstSprite to vLastSprite
    set the cursor of sprite n to 0
  end repeat
end

on hNoteBook
  set lIntNotebookLines to the lineCount of member "notebook text field"
  if lIntNotebookLines = 0 then
    nothing()
  else
    set the text of member "notebook text field" to the text of member "notebook text field" & RETURN & RETURN
    set lIntNotebookLines to the lineCount of member "notebook text field"
  end if
  set the scrollTop of member "notebook text field" to (lIntNotebookLines * 16) + 1
  set the visible of sprite 33 to 1
  set the loc of sprite 33 to point(320, 240)
  set the visible of sprite 32 to 1
  hCursorTrue(32, 32)
  set the visible of sprite 34 to 1
  set the editableText of sprite 34 to 1
  updateStage()
  set the selEnd to length(field "notebook text field")
  set the selStart to length(field "notebook text field") + 1
  updateStage()
end

on hSpriteSwitch vWhichList, vwhichMember
  global gLstMainMap
  repeat with x = 1 to count(vWhichList)
    set lSpriteName to getPropAt(vWhichList, x)
    set lPropValue to getProp(vWhichList, lSpriteName)
    if lPropValue = 1 then
      set the castNum of sprite lSpriteName to the number of member vwhichMember
    end if
  end repeat
end

on hAnimate vFirstMember, vLastMember, vWhichSprite, vCycle
  puppetSprite(vWhichSprite, 1)
  set start to the number of member vFirstMember
  set finish to the number of member vLastMember
  repeat with x = vCycle down to 1
    repeat with y = start to finish
      set the memberNum of sprite vWhichSprite to y
    end repeat
  end repeat
  puppetSprite(vWhichSprite, 0)
end

on hHighLight vWhichSprite, vHighLightChannel
  if rollOver(vWhichSprite) then
    hUnHideSprite(vHighLightChannel, vHighLightChannel)
  else
    hHideSprite(vHighLightChannel, vHighLightChannel)
  end if
end

on hSlideYear vGreaterMseH, vLesserMseH, vWhichYear, lIntHorizontal
  global gLstYears, gWhichYear, gNextYear
  cursor(200)
  set lIntHorizontal to the mouseH
  if (lIntHorizontal >= vGreaterMseH) and (lIntHorizontal <= vLesserMseH) then
    set gNextYear to vWhichYear
    set x to getProp(gLstYears, vWhichYear)
    if x = 1 then
      set LyearHilight to vWhichYear & "hilight"
      set the castNum of sprite 4 to the number of member LyearHilight
      updateStage()
    else
      set the castNum of sprite 4 to the number of member vWhichYear
    end if
    set the loc of sprite 4 to point(lIntHorizontal, 422)
    set the loc of sprite 14 to point(lIntHorizontal, 422)
    updateStage()
  end if
end

on hSliderBar lIntHorizontal
  global gLstYears, gSummary, gWhichYear, gNextYear
  set the constraint of sprite 14 to 13
  set the moveableSprite of sprite 4 to 1
  set the constraint of sprite 4 to 13
  if the clickOn = 4 then
    repeat while the mouseDown
      set lIntHorizontal to the mouseH
      set the cursor of sprite 4 to 200
      hUnHideSprite(6, 6)
      hpuppetTrue(14, 14)
      hSlideYear(14, 45, "1946", lIntHorizontal)
      hSlideYear(46, 77, "1948", lIntHorizontal)
      hSlideYear(78, 109, "1949", lIntHorizontal)
      hSlideYear(110, 141, "1950", lIntHorizontal)
      hSlideYear(142, 173, "1952", lIntHorizontal)
      hSlideYear(174, 205, "1953", lIntHorizontal)
      hSlideYear(206, 237, "1954", lIntHorizontal)
      hSlideYear(238, 269, "1955", lIntHorizontal)
      hSlideYear(270, 301, "1956", lIntHorizontal)
      hSlideYear(302, 333, "1960", lIntHorizontal)
      hSlideYear(334, 364, "1961", lIntHorizontal)
      hSlideYear(365, 396, "1962", lIntHorizontal)
      hSlideYear(397, 428, "1963", lIntHorizontal)
      hSlideYear(429, 460, "1964", lIntHorizontal)
    end repeat
    cursor(-1)
    hpuppetFalse(1, 1)
    hCursorTrue(4, 4)
    hHideSprite(6, 6)
    updateStage()
    if gWhichYear <> gNextYear then
      go(gNextYear)
    end if
  end if
  hpuppetFalse(14, 14)
end

on hDownState vwhichMember, vWhichSound
  hpuppetTrue(the clickOn, the clickOn)
  hCursorTrue(the clickOn, the clickOn)
  set h to the locH of sprite the clickOn
  set v to the locV of sprite the clickOn
  if the machineType = 256 then
    sound playFile 1, the pathName & "audio\" & vWhichSound
  else
    sound playFile 1, the pathName & "audio:" & vWhichSound
  end if
  hDisplay(0, 0, the clickOn, vwhichMember, h, v)
end

on hUpState vwhichMember
  set h to the locH of sprite the clickOn
  set v to the locV of sprite the clickOn
  hDisplay(0, 0, the clickOn, vwhichMember, h, v)
  hpuppetFalse(the clickOn, the clickOn)
  hCursorTrue(the clickOn, the clickOn)
end

on hRollTag vWhichSpriteRoll, vWhichUnHide
  if rollOver(vWhichSpriteRoll) and (the mouseCast = the memberNum of sprite vWhichSpriteRoll) then
    hUnHideSprite(vWhichUnHide, vWhichUnHide)
  else
    hHideSprite(vWhichUnHide, vWhichUnHide)
  end if
end

on hRollFlame vWhichSprite, vHighLightChannel
  global gMarkerName, gBoolRollSound
  if rollOver(vWhichSprite) then
    case gMarkerName of
      "1948", "1953", "1960", "1962", "1964":
        setProp(gLstYears, gMarkerName, 1)
    end case
  else
    hHideSprite(vHighLightChannel, vHighLightChannel)
  end if
  repeat while rollOver(vWhichSprite)
    if gBoolRollSound then
      hSound(1, "s25i02b.aif")
    end if
    case vWhichSprite of
      16:
        hUnHideSprite(20, 20)
        hHideSprite(21, 22)
      17:
        hUnHideSprite(21, 21)
        hHideSprite(20, 20)
        hHideSprite(22, 22)
      18:
        hUnHideSprite(22, 22)
        hHideSprite(20, 21)
    end case
    updateStage()
    set gBoolRollSound to 0
  end repeat
  if the visible of sprite vHighLightChannel = 0 then
    set gBoolRollSound to 1
  end if
end

on hChickletDown
  hSound(1, "click.aif")
  set x to the locH of sprite the clickOn
  set y to the locV of sprite the clickOn
  hDisplay(0, 0, the clickOn, "downState", x, y)
end

on hChickletUp
  set x to the locH of sprite the clickOn
  set y to the locV of sprite the clickOn
  hDisplay(0, 0, the clickOn, "upState", x, y)
end

on hSetAllDone
  setProp(gLstYears, 1946, 1)
  setProp(gLstYears, 1948, 1)
  setProp(gLstYears, 1949, 1)
  setProp(gLstYears, 1950, 1)
  setProp(gLstYears, 1952, 1)
  setProp(gLstYears, 1953, 1)
  setProp(gLstYears, 1954, 1)
  setProp(gLstYears, 1955, 1)
  setProp(gLstYears, 1956, 1)
  setProp(gLstYears, 1960, 1)
  setProp(gLstYears, 1961, 1)
  setProp(gLstYears, 1962, 1)
  setProp(gLstYears, 1963, 1)
  setProp(gLstYears, 1964, 1)
end

on hSound lIntWhichChannel, lStrWhichSound
  if the machineType = 256 then
    sound playFile lIntWhichChannel, the pathName & "audio\" & lStrWhichSound
  else
    sound playFile lIntWhichChannel, the pathName & "audio:" & lStrWhichSound
  end if
end

on stopMovie
  global gFingerCursor, gFistCursor, gSummary, gLst1946LR, gLst1949LR, gLst1950LR, gLst1952LR, gLst1954LR, gLst1955LR, gLst1956LR, gLst1961LR, gLst1963LR, gLst1948, gLst1953, gLst1960, gLst1962, gLst1964, gLstYears, gMarkerName, gBoolRollSound, gWhichYear
  set gSummary to EMPTY
  set gFingerCursor to EMPTY
  set gFistCursor to EMPTY
  set gLstYears to EMPTY
  set gLst1946LR to EMPTY
  set gLst1948 to EMPTY
  set gLst1949LR to EMPTY
  set gLst1950LR to EMPTY
  set gLst1952LR to EMPTY
  set gLst1953 to EMPTY
  set gLst1954LR to EMPTY
  set gLst1955LR to EMPTY
  set gLst1956LR to EMPTY
  set gLst1960 to EMPTY
  set gLst1961LR to EMPTY
  set gLst1962 to EMPTY
  set gLst1963LR to EMPTY
  set gLst1964 to EMPTY
  set gBoolRollSound to EMPTY
  set gWhichYear to EMPTY
  puppetSprite(42, 0)
  hCCCleanUp()
  set the fileName of castLib "Video" to the pathName & "Video.cxt"
end
